%% ORDFILT2 Example
% From _MATLAB Techniques for Image Processing_ by Steve Eddins.

%%
% An order-statistic filter replaces each pixel value by the k-th
% smallest value in that pixel's neighborhood.  Sometimes you can
% creatively implement image processing operations by calling
% ordfilt2.
%
% One example is a _bright-pixel detector._ How can we use order-statistic
% filtering to find all pixels that are least a certain amount higher than
% all of their neighbors?



















%%
% Answer: By asking ordfilt2 to compute the second-brightest
% pixel value in each neighborhood.

I = imread('cameraman.tif');
imshow(I)
xlabel('Image courtesy of MIT')

%%
second_brightest = ordfilt2(I,24,ones(5, 5));
result = (I - second_brightest) > 10;
imshow(result)

%%
% Copyright 2012-2014 The MathWorks, Inc.