function bw_out = fillWithNeighborIndexing(bw,r,c)

active_pixels = sub2ind(size(bw),r,c);
bw_out = bw;
M = size(bw,1);
neighbor_offsets = [-1, M, 1, -M];

while ~isempty(active_pixels)
    % Set the active pixels to 1.
    bw_out(active_pixels) = 1;
    
    % The new active pixels list is the set of neighbors of the
    % current list.
    active_pixels = bsxfun(@plus,active_pixels,neighbor_offsets);
    active_pixels = active_pixels(:);
    
    % Remove from the active_pixels list pixels that are already
    % 1.  This is how we keep the flood fill operation "inside"
    % the white boundaries.
    active_pixels(bw_out(active_pixels)) = [];
    
    % Remove duplicates from the list.
    active_pixels = unique(active_pixels);
end
