function tform = randomWalkShearTform(image_size)

% From MATLAB Techniques for Image Processing by Steve Eddins
% Copyright 2012-2014 The MathWorks, Inc.

M = image_size(1);
N = image_size(2);

tdata.xshift = cumsum(((rand(M,1) < 0.5)*4) - 2);
tdata.yshift = cumsum(((rand(N,1) < 0.5)*4) - 2);
tdata.M = M;
tdata.N = N;
tform = maketform('custom',2,2,[],@T_inv,tdata);

%====================================================================
function uv = T_inv(xy,tform)
x = xy(:,1);
y = xy(:,2);

x = round(x);
x = min(max(x,1),tform.tdata.N);

y = round(y);
y = min(max(y,1),tform.tdata.M);

u = x + tform.tdata.xshift(y);
v = y + tform.tdata.yshift(x);

uv = [u,v];
